# XXX generate per-os macro to test
%{expand: %%global this_os_is_%{_os} %%{nil}}
%{?this_os_is_linux:%define	_bindir		/bin}
%{?this_os_is_linux:%define	_libexecdir	/sbin}

#fix read from multiple tape medium (#253917)
%{!?multitape:%define multitape 0}

Summary: A GNU archiving program.
Name: cpio
Version: 2.5
Release: 16.el4
License: GPL
Group: Applications/Archiving
URL: ftp://ftp.gnu.org/pub/gnu/cpio/
Source: ftp://ftp.gnu.org/pub/gnu/cpio/cpio-2.5.tar.gz
Patch0: cpio-2.5-rh.patch
Patch10: cpio-2.4.2-freebsd.patch
Patch11: cpio-2.4.2-bug56346.patch
Patch12: cpio-2.5-i18n-0.1.patch
Patch13: cpio-2.5-nolibnsl.patch
Patch14: cpio-2.5-umask.patch
Patch15: cpio-2.5-lfs.patch
Patch16: cpio-2.5-chmodRaceC.patch
Patch17: cpio-2.5-checksum.patch 
Patch18: cpio-2.5-modificationTimes.patch 
Patch19: cpio-2.5-fileGrows.patch 
Patch20: cpio-2.5-writeOutHeaderBufferOverflow.patch
Patch21: cpio-2.5-protoize.patch
Patch22: cpio-2.5-eot_mark.patch

%ifnos linux
Prereq: /sbin/rmt
%endif
Prereq: /sbin/install-info
BuildRequires: texinfo
BuildRequires: rsh
Buildroot: %{_tmppath}/%{name}-root

%description
GNU cpio copies files into or out of a cpio or tar archive.  Archives
are files which contain a collection of other files plus information
about them, such as their file name, owner, timestamps, and access
permissions.  The archive can be another file on the disk, a magnetic
tape, or a pipe.  GNU cpio supports the following archive formats:  binary,
old ASCII, new ASCII, crc, HPUX binary, HPUX old ASCII, old tar and POSIX.1
tar.  By default, cpio creates binary format archives, so that they are
compatible with older cpio programs.  When it is extracting files from
archives, cpio automatically recognizes which kind of archive it is reading
and can read archives created on machines with a different byte-order.

Install cpio if you need a program to manage file archives.

%prep
%setup -q
%patch0 -p1 -b .rh
#%patch10 -p1 -b .fbsd
#%patch11 -p1 -b .multilink
%patch12 -p1 -b .i18n
%patch13 -p1 -b .nolibnsl
%patch14 -p1 -b .umask
%patch15 -p1 -b .lfs
%patch16 -p1 -b .chmodRaceC
%patch17 -p1 -b .checksum
%patch18 -p1 -b .modificationTimes
%patch19 -p1 -b .fileGrows
%patch20 -p1 -b .bufferOverflow
%patch21 -p1 -b .protoize
%patch22 -p1 -b .eot_mark

%build

CFLAGS="$RPM_OPT_FLAGS -Wall -D_BSD_SOURCE -D_FILE_OFFSET_BITS=64 \
%if %{multitape}
 -DUSE_MULTI_TAPE \
%endif
 -D_LARGEFILE64_SOURCE" %configure
make

%install
rm -rf ${RPM_BUILD_ROOT}

%makeinstall

{ cd ${RPM_BUILD_ROOT}

%ifos linux
# XXX these from mt-st
  rm -f .%{_bindir}/mt .%{_mandir}/man1/mt.1
%endif

# XXX Nuke unpackaged files.
  rm -f .%{_infodir}/dir
  rm -f ./sbin/rmt
}

%clean
rm -rf ${RPM_BUILD_ROOT}

%post
/sbin/install-info %{_infodir}/cpio.info.gz %{_infodir}/dir

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete %{_infodir}/cpio.info.gz %{_infodir}/dir
fi

%files
%defattr(-,root,root)
%doc README NEWS

%ifnos linux
%{_libexecdir}/*
%endif
%{_bindir}/*
%{_mandir}/man*/*

%{_infodir}/*.info*

%changelog
* Wed Jun 25 2008 Ondrej Vasik <ovasik@redhat.com> 2.5-16.el4
- change multiple archive fix in 2.5-14.el4 (bz#253917) 
  (now the code is ifdef'd instead of removed to prevent possible 
   regressions and could be deactivated by rebuilding from srpm 
   with multitape 1)

* Thu Jun 19 2008 Ondrej Vasik <ovasik@redhat.com> 2.5-15.el4
- BuildRequires: rsh (gcc compiler option -DHAVE_NETDB_H=1 brew 
  fallback is causing rsh unfunctionality) - #238862

* Tue Apr 15 2008 Radek Brich <rbrich@redhat.com> 2.5-14.el4
- fix writing multitape archives (bz#253917)

* Wed Jan 31 2007 Peter Vrabec <pvrabec@redhat.com> 2.5-13.RHEL4
- protoize cpio source
- Resolves #217375

* Mon Oct 09 2006 Peter Vrabec <pvrabec@redhat.com> 2.5-12.RHEL4
- improve previous fix of lfs.patch

* Thu Sep 28 2006 Peter Vrabec <pvrabec@redhat.com> 2.5-11.RHEL4
- improve previous fix of lfs.patch

* Mon Sep 25 2006 Peter Vrabec <pvrabec@redhat.com> 2.5-10.RHEL4
- fix cpio large filesize buffer overflow (#172865)
- fix exit codes (#183224)

* Sat Apr 09 2006 Peter Vrabec <pvrabec@redhat.com> 2.5-9.RHEL4
- fix checksum error on 64-bit machines (#171649)
- fix problem with file modification times stored in the archive(#168401)
- fix problem when file grew n bytes in copy-pass mode and these 
  n bytes got prepended to the contents of all subsequent files (#167845)

* Mon Jun 27 2005 Peter Vrabec <pvrabec@redhat.com> 2.5-8.RHEL4
- fix large file support, archive >4GiB, archive members <4GiB (#160056)
- use mode 0700 for dir creation

* Thu Apr 28 2005 Peter Vrabec <pvrabec@redhat.com> 2.5-7.EL4.3
- fix race condition (#155749)

* Tue Apr 12 2005 Peter Vrabec <pvrabec@redhat.com>
- large file support > 2GB (#154507)

* Tue Jan 25 2005 Peter Vrabec <pvrabec@redhat.com>
- insecure file creation (#145720) 2.5-7.EL4.1

* Thu Oct 21 2004 Peter Vrabec <pvrabec@redhat.com>
- fix dependencies in spec

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Sep 23 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- do not link against -lnsl

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 14 2003 Jeff Johnson <jbj@redhat.com> 2.5-3
- setlocale for i18n compliance (#79136).

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Mon Nov 18 2002 Jeff Johnson <jbj@redhat.com> 2.5-1
- update 2.5, restack and consolidate patches.
- don't apply (but include for now) freebsd and #56346 patches.
- add url (#54598).

* Thu Nov  7 2002 Jeff Johnson <jbj@redhat.com> 2.4.2-30
- rebuild from CVS.

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu Nov 22 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.4.2-25
- Fix up extraction of multiply linked files when the first link is
  excluded (Bug #56346)

* Mon Oct  1 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.4.2-24
- Merge and adapt patches from FreeBSD, this should fix FIFO handling

* Tue Jun 26 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add and adapt Debian patch (pl36), fixes #45285 and a couple of other issues

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Tue Aug  8 2000 Jeff Johnson <jbj@redhat.com>
- update man page with decription of -c behavior (#10581).

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Thu Jun 29 2000 Preston Brown <pbrown@redhat.com>
- patch from HJ Lu for better error codes upon exit

* Mon Jun  5 2000 Jeff Johnson <jbj@redhat.com>
- FHS packaging.

* Wed Feb  9 2000 Jeff Johnson <jbj@redhat.com>
- missing defattr.

* Mon Feb  7 2000 Bill Nottingham <notting@redhat.com>
- handle compressed manpages

* Fri Dec 17 1999 Jeff Johnson <jbj@redhat.com>
- revert the stdout patch (#3358), restoring original GNU cpio behavior
  (#6376, #7538), the patch was dumb.

* Tue Aug 31 1999 Jeff Johnson <jbj@redhat.com>
- fix infinite loop unpacking empty files with hard links (#4208).
- stdout should contain progress information (#3358).

* Sun Mar 21 1999 Crstian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 12)

* Sat Dec  5 1998 Jeff Johnson <jbj@redhat.com>
- longlong dev wrong with "-o -H odc" headers (formerly "-oc").

* Thu Dec 03 1998 Cristian Gafton <gafton@redhat.com>
- patch to compile on glibc 2.1, where strdup is a macro

* Tue Jul 14 1998 Jeff Johnson <jbj@redhat.com>
- Fiddle bindir/libexecdir to get RH install correct.
- Don't include /sbin/rmt -- use the rmt from dump package.
- Don't include /bin/mt -- use the mt from mt-st package.
- Add prereq's

* Tue Jun 30 1998 Jeff Johnson <jbj@redhat.com>
- fix '-c' to duplicate svr4 behavior (problem #438)
- install support programs & info pages

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Fri Oct 17 1997 Donnie Barnes <djb@redhat.com>
- added BuildRoot
- removed "(used by RPM)" comment in Summary

* Thu Jun 19 1997 Erik Troan <ewt@redhat.com>
- built against glibc
- no longer statically linked as RPM doesn't use cpio for unpacking packages
